package org.fouram.service;

import java.util.Iterator;

import org.fouram.core.base.service.BaseService;
import org.fouram.core.util.JsonNodeUtil;
import org.fouram.entity.SapContract;
import org.springframework.http.HttpHeaders;
import org.springframework.stereotype.Service;

import com.fasterxml.jackson.databind.JsonNode;

@Service
public class SapContractService extends BaseService {

	public void saveSapData() throws Exception {
		HttpHeaders headers = getHttpHeaders();

		delete("SapContractMapper.deleteAll", null);

		String url = "https://api15.sapsf.cn/odata/v2/cust_Contract?$format=json&$expand=cust_LegalNav";
		JsonNode node = requestService.getForObject(url, headers);
		if (node != null) {
			Iterator<JsonNode> iterator = node.get("d").get("results").elements();
			while (iterator.hasNext()) {
				JsonNode userNode = iterator.next();
				String userId = JsonNodeUtil.getValue(userNode, "externalCode");
				String startDate = JsonNodeUtil.getValue(userNode, "cust_BEGDA");
				String legalName = JsonNodeUtil.getValue(userNode, "cust_LegalNav", "name");
				SapContract entity = SapContract.builder().userId(userId).startDate(startDate).legalName(legalName)
						.build();
				save("SapContractMapper.save", entity);
			}
		}
	}
}
