package org.fouram.service;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.fouram.core.base.service.BaseService;
import org.fouram.core.base.service.RequestService;
import org.fouram.core.util.JsonNodeUtil;
import org.fouram.entity.SapUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.fasterxml.jackson.databind.JsonNode;
import com.google.common.collect.Maps;

@Service
public class SapPerNationalIdService extends BaseService {

	@Autowired
	private RequestService requestService;

	public void setCardInfo(List<SapUser> sapUsers) {
		String url = "https://api15.sapsf.cn/odata/v2/PerNationalId?$format=json";
		JsonNode jsonNode = requestService.getForObject(url, getHttpHeaders());
		Map<String, String> nationalIdMap = Maps.newHashMap();
		Map<String, String> cardTypeMap = Maps.newHashMap();
		if (jsonNode != null) {
			Iterator<JsonNode> iterator = jsonNode.get("d").get("results").elements();
			while (iterator.hasNext()) {
				JsonNode node = iterator.next();
				String userId = JsonNodeUtil.getValue(node, "personIdExternal");
				nationalIdMap.put(userId, JsonNodeUtil.getValue(node, "nationalId"));
				cardTypeMap.put(userId, JsonNodeUtil.getValue(node, "cardType"));
			}
		}
		for (SapUser sapUser : sapUsers) {
			sapUser.setCardId(nationalIdMap.get(sapUser.getUserId()));
			sapUser.setCardType(cardTypeMap.get(sapUser.getUserId()));
		}
	}
}
